欢迎您访问程序员文章站本站旨在为大家提供分享程序员计算机编程知识!
您现在的位置是: 首页

贪心---hdu-1050-Moving Tables

程序员文章站 2022-03-05 14:53:27
...

Moving Tables

Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 65536/32768 K (Java/Others)
Total Submission(s): 41091    Accepted Submission(s): 13501


 

Problem Description

The famous ACM (Advanced Computer Maker) Company has rented a floor of a building whose shape is in the following figure.
 

 

贪心---hdu-1050-Moving Tables

The floor has 200 rooms each on the north side and south side along the corridor. Recently the Company made a plan to reform its system. The reform includes moving a lot of tables between rooms. Because the corridor is narrow and all the tables are big, only one table can pass through the corridor. Some plan is needed to make the moving efficient. The manager figured out the following plan: Moving a table from a room to another room can be done within 10 minutes. When moving a table from room i to room j, the part of the corridor between the front of room i and the front of room j is used. So, during each 10 minutes, several moving between two rooms not sharing the same part of the corridor will be done simultaneously. To make it clear the manager illustrated the possible cases and impossible cases of simultaneous moving.
 

 

贪心---hdu-1050-Moving Tables

For each room, at most one table will be either moved in or moved out. Now, the manager seeks out a method to minimize the time to move all the tables. Your job is to write a program to solve the manager’s problem.

 

 

Input

The input consists of T test cases. The number of test cases ) (T is given in the first line of the input. Each test case begins with a line containing an integer N , 1<=N<=200 , that represents the number of tables to move. Each of the following N lines contains two positive integers s and t, representing that a table is to move from room number s to room number t (each room number appears at most once in the N lines). From the N+3-rd line, the remaining test cases are listed in the same manner as above.

 

 

Output

The output should contain the minimum time in minutes to complete the moving, one per line.

 

Sample Input

 

3

4

10  20

30  40

50  60

70  80

 

2

1   3

2   200

 

3

10  100

20   80

30   50

 

Sample Output

10 
20 
30

Source
Asia 2001, Taejon (South Korea) 

题意 :北面 200 个房间,南面 200 个房间,给出 n 对房间号(1,2),问你把 n 对 1 房间的桌子移动 2 房间所需要的时间,条               件是:每移动一次需要花费 10 分钟,如果两个搬运路线不相交可以同时进行。

题解:第一次我是这么想的:把每次搬运路线看成一个集合,然后暴力寻找集合相交的最大次数,结果 wa;原因在于:

            贪心---hdu-1050-Moving Tables

           第二次我是这么想的:总长200,可以压缩成200个单元格,每次搬运路线所经过的单元格依次 加一,求经过某一单元格的                                                    最大次数。

#include<stdio.h>
#include<string.h>
#include<algorithm>
using namespace std;

struct fun{
	int a,b;
}f[205];

bool cmp(fun x,fun y){
	return x.a<y.a;
}
int main(){
	int t,n;
	scanf("%d",&t);
	while(t--){
		scanf("%d",&n);
		int sum[205]={0};
		for(int i=0;i<n;i++){
			scanf("%d %d",&f[i].a,&f[i].b);
			if(f[i].a>f[i].b){         // 如果有 30-->20 改为 20--->30 
				int t=f[i].a;
				f[i].a=f[i].b;
				f[i].b=t;
			}
		}
		sort(f,f+n,cmp);
		int ans=0;
		for(int i=0;i<n;i++){
			int h1,h2;
			if(f[i].a%2==0){        //  压缩 
				h1=f[i].a>>1;
			}
			else{
				h1=(f[i].a+1)>>1;
			}
			if(f[i].b%2==0){
				h2=f[i].b>>1;
			}
			else{
				h2=(f[i].b+1)>>1;
			}
			for(int j=h1;j<=h2;j++){
				sum[j]++;
			}
		}
		for(int i=0;i<=200;i++){
			ans=max(ans,sum[i]);
		}
		printf("%d\n",ans*10);
	}
	return 0;
}

 

相关标签: 贪心